/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2015                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2015                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

#ifndef CUBE_VERSION_H
#define CUBE_VERSION_H


/*-------------------------------------------------------------------------*/
/**
 *  @file  cube-version.h
 *  @brief Provides the Cube package version information.
 **/
/*-------------------------------------------------------------------------*/


/// @name Cube version information
/// @{

/// Cube revision number
#define CUBE_REVISION "13288"

/// Cube revision number
#define CUBE_REVISION_NUMBER 13288

/// Cube revision number
#define CUBE_REVISION_STRING CUBE_REVISION




/// Cube major version number
#define CUBE_MAJOR   "4"

/// Cube minor version number
#define CUBE_MINOR   "3"

/// Cube bugfix version number
#define CUBE_BUGFIX   "2"

/// Cube suffix
#define CUBE_SUFFIX   ""

/// Cube suffix_internally
#define CUBE_SUFFIX_INTERNAL   

/// Cube version number (<i>major</i>.<i>minor</i>)
#define CUBE_SHORT_VERSION   CUBE_MAJOR "." CUBE_MINOR

/// Cube full version number (<i>major</i>.<i>minor</i>.<i>bugfix</i>)
#define CUBE_FULL_VERSION   CUBE_SHORT_VERSION "." CUBE_BUGFIX

/// Cube version number
#define CUBE_VERSION "4.3.2"

/// Cube package name "cube"
#define CUBE_SHORT_NAME  "Cube"

/// Cube package name "cube-4.x.1-XX"
#define CUBE_FULL_NAME   CUBE_SHORT_NAME "-" CUBE_FULL_VERSION CUBE_SUFFIX 


/// Cube library interface information
#define LIBRARY_CURRENT "7"
#define LIBRARY_REVISION "2"
#define LIBRARY_AGE "0"

/// @}


#endif   // !CUBE_VERSION_H
