/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2015                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2015                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef CUBEPLUGIN_H
#define CUBEPLUGIN_H

#include <QTextStream>
#include "PluginInterface.h"

class PluginServices;

class CubePlugin : public PluginInterface
{
public:
    /**
     * @brief cubeOpened is called after a cube file has been loaded. It should return false, if
     * the plugin should not be started with current data.
     */
    virtual bool
    cubeOpened( PluginServices* service ) = 0;

    /**
     * @brief cubeClosed is called after the cube file has been closed. If resources have been allocated,
     * they should be freed here.
     */
    virtual void
    cubeClosed()
    {
    };

    virtual void
    version( int& major,
             int& minor,
             int& bugfix ) const = 0;

    virtual QString
    name() const = 0;

    virtual QString
    getHelpText() const = 0;

    bool isInitialized;
};

Q_DECLARE_INTERFACE( CubePlugin, PLUGIN_VERSION )

#endif
