#ifndef PLUGININTERFACE_H
#define PLUGININTERFACE_H


/*
   CUBE_PLUGIN_VERSION is (major << 8) + minor
 */
#define CUBE_PLUGIN_VERSION 0x0100
#define PLUGIN_VERSION "cubeplugin/1.0"

class PluginInterface
{
public:
    virtual void
    version( int& major,
             int& minor,
             int& bugfix ) const = 0;

    virtual QString
    name() const = 0;

    virtual QString
    getHelpText() const = 0;

    QString
    versionLabel()
    {
        int major, minor, bugfix;
        version( major, minor, bugfix );
        QString     label;
        QTextStream out( &label );
        out << name() << " V" << major << "." << minor << "." << bugfix;
        return label;
    }
    virtual
    ~PluginInterface()
    {
    }
};
Q_DECLARE_INTERFACE( PluginInterface, PLUGIN_VERSION )

#endif // PLUGININTERFACE_H
