#ifndef TREEITEMMARKER_H
#define TREEITEMMARKER_H

#include <QColor>
#include <QIcon>

class MarkerAttributes
{
public:
    MarkerAttributes();

    MarkerAttributes( const QColor& c );

    const QColor&
    getColor() const;

    void
    release();

    static MarkerAttributes
    getMarkerAttributes();

private:
    static QList<MarkerAttributes > definedMarkers;
    QColor                          color;
};

/**
 * TreeItemMarker is used to visually mark tree items in the view.
 */
class TreeItemMarker
{
    friend class PluginServices;
public:
    ~TreeItemMarker();
    const MarkerAttributes&
    getAttributes() const;
    const QString&
    getLabel() const;

private:
    TreeItemMarker( const QString& label,
                    const QIcon*   icon = 0 );
    QString          label;
    MarkerAttributes attribute;
    const QIcon*     icon;
};

#endif // TREEITEMMARKER_H
